#
# ------------------------------------------------------------------
#   Task
# ------------------------------------------------------------------
#   Version: 02V06
#   Date   : 221005
#   Time   : 1522
#   Author : OMDevelop
#
import threading
import time
#
class CTask:
    def __init__(self, id, cbonstart, cbonabort, cbonexecute):
        self.ID = id
        self.FThread = None
        self.DoLoop = True
        self.CBOnStart = cbonstart
        self.CBOnAbort = cbonabort
        self.CBOnExecute = cbonexecute
    #
    def SetCBOnExecute(self, callback):
        self.CBOnExecute = callback
    #
    def IsBusy(self):
        return self.DoLoop
    #
    def Start(self):
        self.DoLoop = True
        if isinstance(self.FThread, threading.Thread):
            self.Abort()
        self.FThread = None
        self.FThread = threading.Thread(target = self.OnExecute)
        self.FThread.start()
        if (None != self.CBOnStart):
            self.CBOnStart(self)
    #
    def Abort(self):
        self.DoLoop = False
        if (None != self.CBOnAbort):
            self.CBOnAbort(self)
        self.FThread.join()
    #
    def OnExecute(self):
        try:
            self.DoLoop = True;
            while (True == self.DoLoop):
                if (None != self.CBOnExecute):
                    self.CBOnExecute(self)
            self.FThread.join()
        except:
            pass

